'/*
'   BASSCD 2.4 C/C++ header file
'   Copyright (c) 2003-2008 Un4seen Developments Ltd.

'   See the BASSCD.CHM file for more detailed documentation
'*/

#IF NOT %DEF(%BASSCD_INC)
    %BASSCD_INC = 1

#INCLUDE "bass.inc"

#IF %BASSVERSION = &H204

' // Additional error codes returned by BASS_ErrorGetCode
%BASS_ERROR_NOCD              = 12              ' // no CD in drive
%BASS_ERROR_CDTRACK           = 13              ' // invalid track number
%BASS_ERROR_NOTAUDIO          = 17              ' // not an audio track

' // Additional BASS_SetConfig options
%BASS_CONFIG_CD_FREEOLD       = &H10200???
%BASS_CONFIG_CD_RETRY         = &H10201???
%BASS_CONFIG_CD_AUTOSPEED     = &H10202???
%BASS_CONFIG_CD_SKIPERROR     = &H10203???

' // BASS_CD_SetInterface options
%BASS_CD_IF_AUTO              = 0
%BASS_CD_IF_SPTI              = 1
%BASS_CD_IF_ASPI              = 2
%BASS_CD_IF_WIO               = 3

TYPE BASS_CD_INFO
   vendor   AS ASCIIZ PTR   ' const char *vendor // manufacturer
   product  AS ASCIIZ PTR   ' const char *product // model
   rev      AS ASCIIZ PTR   ' const char *rev // revision
   letter   AS LONG         ' int letter // drive letter
   rwflags  AS DWORD        ' DWORD rwflags // read/write capability flags
   canopen  AS LONG         ' BOOL canopen // BASS_CD_DOOR_OPEN/CLOSE is supported?
   canlock  AS LONG         ' BOOL canlock // BASS_CD_DOOR_LOCK/UNLOCK is supported?
   maxspeed AS DWORD        ' DWORD maxspeed // max read speed (KB/s)
   cache    AS DWORD        ' DWORD cache // cache size (KB)
   cdtext   AS LONG         ' BOOL cdtext // can read CD-TEXT
END TYPE

' // "rwflag" read capability flags
%BASS_CD_RWFLAG_READCDR       = 1
%BASS_CD_RWFLAG_READCDRW      = 2
%BASS_CD_RWFLAG_READCDRW2     = 4
%BASS_CD_RWFLAG_READDVD       = 8
%BASS_CD_RWFLAG_READDVDR      = 16
%BASS_CD_RWFLAG_READDVDRAM    = 32
%BASS_CD_RWFLAG_READANALOG    = &H10000???
%BASS_CD_RWFLAG_READM2F1      = &H100000???
%BASS_CD_RWFLAG_READM2F2      = &H200000???
%BASS_CD_RWFLAG_READMULTI     = &H400000???
%BASS_CD_RWFLAG_READCDDA      = &H1000000???
%BASS_CD_RWFLAG_READCDDASIA   = &H2000000???
%BASS_CD_RWFLAG_READSUBCHAN   = &H4000000???
%BASS_CD_RWFLAG_READSUBCHANDI = &H8000000???
%BASS_CD_RWFLAG_READISRC      = &H20000000???
%BASS_CD_RWFLAG_READUPC       = &H40000000???

' // additional BASS_CD_StreamCreate/File flags
%BASS_CD_SUBCHANNEL           = &H200???
%BASS_CD_SUBCHANNEL_NOHW      = &H400???

' // additional CD sync types
%BASS_SYNC_CD_ERROR           = 1000
%BASS_SYNC_CD_SPEED           = 1002

' // BASS_CD_Door actions
%BASS_CD_DOOR_CLOSE           = 0
%BASS_CD_DOOR_OPEN            = 1
%BASS_CD_DOOR_LOCK            = 2
%BASS_CD_DOOR_UNLOCK          = 3

' // BASS_CD_GetID flags
%BASS_CDID_UPC                = 1
%BASS_CDID_CDDB               = 2
%BASS_CDID_CDDB2              = 3
%BASS_CDID_TEXT               = 4
%BASS_CDID_CDPLAYER           = 5
%BASS_CDID_MUSICBRAINZ        = 6
%BASS_CDID_ISRC               = &H100???   ' // + track #

' // BASS_CHANNELINFO type
%BASS_CTYPE_STREAM_CD         = &H10200???

' ========================================================================================
' Sets the interface to use to access CD drives.
' DWORD BASSCDDEF(BASS_CD_SetInterface)(DWORD iface);
' ========================================================================================
DECLARE FUNCTION BASS_CD_SetInterface LIB "basscd.dll" ALIAS "BASS_CD_SetInterface" ( _
   BYVAL DWORD _                              ' __in DWORD iface
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Retrieves information on a drive.
' BOOL BASSCDDEF(BASS_CD_GetInfo)(DWORD drive, BASS_CD_INFO *info);
' ========================================================================================
DECLARE FUNCTION BASS_CD_GetInfo LIB "basscd.dll" ALIAS "BASS_CD_GetInfo" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 , BYREF BASS_CD_INFO _                       ' __out BASS_CD_INFO *info
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Opens, closes, locks or unlocks a drive door.
' BOOL BASSCDDEF(BASS_CD_Door)(DWORD drive, DWORD action);
' ========================================================================================
DECLARE FUNCTION BASS_CD_Door LIB "basscd.dll" ALIAS "BASS_CD_Door" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 , BYVAL DWORD _                              ' __in DWORD action
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Checks if a drive door/tray is open.
' BOOL BASSCDDEF(BASS_CD_DoorIsOpen)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_DoorIsOpen LIB "basscd.dll" ALIAS "BASS_CD_DoorIsOpen" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Checks if a drive door/tray is locked.
' BOOL BASSCDDEF(BASS_CD_DoorIsLocked)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_DoorIsLocked LIB "basscd.dll" ALIAS "BASS_CD_DoorIsLocked" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Checks if there is a CD ready in a drive.
' BOOL BASSCDDEF(BASS_CD_IsReady)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_IsReady LIB "basscd.dll" ALIAS "BASS_CD_IsReady" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Retrieves the number of tracks on the CD in a drive.
' DWORD BASSCDDEF(BASS_CD_GetTracks)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_GetTracks LIB "basscd.dll" ALIAS "BASS_CD_GetTracks" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Retrieves the length (in bytes) of a track.
' DWORD BASSCDDEF(BASS_CD_GetTrackLength)(DWORD drive, DWORD track);
' ========================================================================================
DECLARE FUNCTION BASS_CD_GetTrackLength LIB "basscd.dll" ALIAS "BASS_CD_GetTrackLength" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 , BYVAL DWORD _                              ' __in DWORD track
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Retrieves the pregap length (in bytes) of a track.
' DWORD BASSCDDEF(BASS_CD_GetTrackPregap)(DWORD drive, DWORD track);
' ========================================================================================
DECLARE FUNCTION BASS_CD_GetTrackPregap LIB "basscd.dll" ALIAS "BASS_CD_GetTrackPregap" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 , BYVAL DWORD _                              ' __in DWORD track
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Retrieves identification info from the CD in a drive.
' const char *BASSCDDEF(BASS_CD_GetID)(DWORD drive, DWORD id);
' ========================================================================================
DECLARE FUNCTION BASS_CD_GetID LIB "basscd.dll" ALIAS "BASS_CD_GetID" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 , BYVAL DWORD _                              ' __in DWORD id
 ) AS DWORD                                   ' char *

' ========================================================================================
' Retrieves the current read speed setting of a drive.
' DWORD BASSCDDEF(BASS_CD_GetSpeed)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_GetSpeed LIB "basscd.dll" ALIAS "BASS_CD_GetSpeed" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Sets the read speed of a drive.
' BOOL BASSCDDEF(BASS_CD_SetSpeed)(DWORD drive, DWORD speed);
' ========================================================================================
DECLARE FUNCTION BASS_CD_SetSpeed LIB "basscd.dll" ALIAS "BASS_CD_SetSpeed" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 , BYVAL DWORD _                              ' __in DWORD speed
 ) AS LONG                                    ' BOOL

' ========================================================================================
' DWORD BASSCDDEF(BASS_CD_GetCache)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_GetCache LIB "basscd.dll" ALIAS "BASS_CD_GetCache" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' BOOL BASSCDDEF(BASS_CD_SetCache)(DWORD drive, BOOL enable);
' ========================================================================================
DECLARE FUNCTION BASS_CD_SetCache LIB "basscd.dll" ALIAS "BASS_CD_SetCache" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 , BYVAL LONG _                               ' __in BOOL enable
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Releases a drive to allow other applications to access it.
' BOOL BASSCDDEF(BASS_CD_Release)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_Release LIB "basscd.dll" ALIAS "BASS_CD_Release" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Creates a sample stream from an audio CD track.
' HSTREAM BASSCDDEF(BASS_CD_StreamCreate)(DWORD drive, DWORD track, DWORD flags);
' ========================================================================================
DECLARE FUNCTION BASS_CD_StreamCreate LIB "basscd.dll" ALIAS "BASS_CD_StreamCreate" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 , BYVAL DWORD _                              ' __in DWORD track
 , BYVAL DWORD _                              ' __in DWORD flags
 ) AS DWORD                                   ' HSTREAM

' ========================================================================================
' Creates a sample stream from an audio CD track, using a CDA file on the CD.
' HSTREAM BASSCDDEF(BASS_CD_StreamCreateFile)(const char *file, DWORD flags);
' ========================================================================================
DECLARE FUNCTION BASS_CD_StreamCreateFile LIB "basscd.dll" ALIAS "BASS_CD_StreamCreateFile" ( _
   BYREF ASCIIZ _                             ' __in const char *file
 , BYVAL DWORD _                              ' __in DWORD flags
 ) AS DWORD                                   ' HSTREAM

' ========================================================================================
' Retrieves the drive and track number of a CD stream.
' DWORD BASSCDDEF(BASS_CD_StreamGetTrack)(HSTREAM handle);
' ========================================================================================
DECLARE FUNCTION BASS_CD_StreamGetTrack LIB "basscd.dll" ALIAS "BASS_CD_StreamGetTrack" ( _
   BYVAL DWORD _                              ' __in HSTREAM handle
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Changes the track of a CD stream.
' BOOL BASSCDDEF(BASS_CD_StreamSetTrack)(HSTREAM handle, DWORD track);
' ========================================================================================
DECLARE FUNCTION BASS_CD_StreamSetTrack LIB "basscd.dll" ALIAS "BASS_CD_StreamSetTrack" ( _
   BYVAL DWORD _                              ' __in HSTREAM handle
 , BYVAL DWORD _                              ' __in DWORD track
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Starts analog playback of an audio CD track.
' BOOL BASSCDDEF(BASS_CD_Analog_Play)(DWORD drive, DWORD track, DWORD pos);
' ========================================================================================
DECLARE FUNCTION BASS_CD_Analog_Play LIB "basscd.dll" ALIAS "BASS_CD_Analog_Play" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 , BYVAL DWORD _                              ' __in DWORD track
 , BYVAL DWORD _                              ' __in DWORD pos
 ) AS LONG                                    ' BOOL

' ========================================================================================
' DWORD BASSCDDEF(BASS_CD_Analog_PlayFile)(const char *file, DWORD pos);
' ========================================================================================
DECLARE FUNCTION BASS_CD_Analog_PlayFile LIB "basscd.dll" ALIAS "BASS_CD_Analog_PlayFile" ( _
   BYREF ASCIIZ _                             ' __in const char *file
 , BYVAL DWORD _                              ' __in DWORD pos
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Starts analog playback of an audio CD track, using a CDA file on the CD.
' BOOL BASSCDDEF(BASS_CD_Analog_Stop)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_Analog_Stop LIB "basscd.dll" ALIAS "BASS_CD_Analog_Stop" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Checks if analog playback is in progress on a drive.
' DWORD BASSCDDEF(BASS_CD_Analog_IsActive)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_Analog_IsActive LIB "basscd.dll" ALIAS "BASS_CD_Analog_IsActive" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Retrieves the current position on a drive.
' DWORD BASSCDDEF(BASS_CD_Analog_GetPosition)(DWORD drive);
' ========================================================================================
DECLARE FUNCTION BASS_CD_Analog_GetPosition LIB "basscd.dll" ALIAS "BASS_CD_Analog_GetPosition" ( _
   BYVAL DWORD _                              ' __in DWORD drive
 ) AS DWORD                                   ' DWORD

#ENDIF   ' #IF %BASSVERSION = &H204

#ENDIF   ' %BASSCD_INC
