'/*
'   BASSWMA 2.4 C/C++ header file
'   Copyright (c) 2002-2008 Un4seen Developments Ltd.

'   See the BASSWMA.CHM file for more detailed documentation
'*/

#IF NOT %DEF(%BASSWMA_INC)
    %BASSWMA_INC = 1

#INCLUDE "bass.inc"

#IF %BASSVERSION = &H204

'typedef DWORD HWMENCODE;   ' // WMA encoding handle

' // Additional error codes returned by BASS_ErrorGetCode
%BASS_ERROR_WMA_LICENSE    = 1000              ' // the file is protected
%BASS_ERROR_WMA            = 1001              ' // Windows Media (9 or above) is not installed
%BASS_ERROR_WMA_WM9        = %BASS_ERROR_WMA
%BASS_ERROR_WMA_DENIED     = 1002              ' // access denied (user/pass is invalid)
%BASS_ERROR_WMA_INDIVIDUAL = 1004              ' // individualization is needed

' // Additional BASS_SetConfig options
%BASS_CONFIG_WMA_PRECHECK  = &H10100???
%BASS_CONFIG_WMA_PREBUF    = &H10101???
%BASS_CONFIG_WMA_BASSFILE  = &H10103???
%BASS_CONFIG_WMA_NETSEEK   = &H10104???

' // additional WMA sync types
%BASS_SYNC_WMA_CHANGE      = &H10100???
%BASS_SYNC_WMA_META        = &H10101???

' // additional BASS_StreamGetFilePosition WMA mode
%BASS_FILEPOS_WMA_BUFFER   = 1000              ' // internet buffering progress (0-100%)

' // Additional flags for use with BASS_WMA_EncodeOpen/File/Network/Publish
%BASS_WMA_ENCODE_STANDARD  = &H2000???            ' // standard WMA
%BASS_WMA_ENCODE_PRO       = &H4000???            ' // WMA Pro
%BASS_WMA_ENCODE_24BIT     = &H8000???            ' // 24-bit
%BASS_WMA_ENCODE_SCRIPT    = &H20000???           ' // set script (mid-stream tags) in the WMA encoding

' // Additional flag for use with BASS_WMA_EncodeGetRates
%BASS_WMA_ENCODE_RATES_VBR = &H10000???           ' // get available VBR quality settings

'typedef void (CALLBACK CLIENTCONNECTPROC)(HWMENCODE handle, BOOL connect, const char *ip, void *user);
'/* Client connection notification callback function.
'handle : The encoder
'connect: TRUE=client is connecting, FALSE=disconnecting
'ip     : The client's IP (xxx.xxx.xxx.xxx:port)
'user   : The 'user' parameter value given when calling BASS_WMA_EncodeSetNotify */

'SUB CLIENTCONNECTPROC (BYVAL handle AS DWORD, BYVAL connect AS LONG, BYREF ip AS ASCIIZ, BYVAL user AS DWORD)

'typedef void (CALLBACK WMENCODEPROC)(HWMENCODE handle, DWORD type, const void *buffer, DWORD length, void *user);
'/* Encoder callback function.
'handle : The encoder handle
'type   : The type of data, one of BASS_WMA_ENCODE_xxx values
'buffer : The encoded data
'length : Length of the data
'user   : The 'user' parameter value given when calling BASS_WMA_EncodeOpen */

'SUB WMENCODEPROC (BYVAL handle AS DWORD, BYVAL type AS DWORD, BYVAL buffer AS DWORD, BYVAL length AS DWORD, BYVAL user AS DWORD)

' // WMENCODEPROC "type" values
%BASS_WMA_ENCODE_HEAD      = 0
%BASS_WMA_ENCODE_DATA      = 1
%BASS_WMA_ENCODE_DONE      = 2

' // BASS_WMA_EncodeSetTag "type" values
%BASS_WMA_TAG_ANSI         = 0
%BASS_WMA_TAG_UNICODE      = 1
%BASS_WMA_TAG_UTF8         = 2

' // BASS_CHANNELINFO type
%BASS_CTYPE_STREAM_WMA     = &H10300???
%BASS_CTYPE_STREAM_WMA_MP3 = &H10301???

' // Additional BASS_ChannelGetTags types
%BASS_TAG_WMA              = 8                 ' // WMA header tags : series of null-terminated UTF-8 strings
%BASS_TAG_WMA_META         = 11                ' // WMA mid-stream tag : UTF-8 string

' ========================================================================================
' Creates a sample stream from a WMA file or URL.
' HSTREAM BASSWMADEF(BASS_WMA_StreamCreateFile)(BOOL mem, const void *file,
' QWORD offset, QWORD length, DWORD flags);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_StreamCreateFile LIB "basswma.dll" ALIAS "BASS_WMA_StreamCreateFile" ( _
   BYVAL LONG _                               ' __in BOOL mem
 , BYREF ANY _                                ' __in const void *file
 , BYVAL QUAD _                               ' __in QWORD offset
 , BYVAL QUAD _                               ' __in QWORD length
 , BYVAL DWORD _                              ' __in DWORD flags
 ) AS DWORD                                   ' HSTREAM

' ========================================================================================
' Creates a sample stream from a WMA file or URL, optionally with a username and password
' to authenticate.
' HSTREAM BASSWMADEF(BASS_WMA_StreamCreateFileAuth)(BOOL mem, const void *file,
' QWORD offset, QWORD length, DWORD flags, const char *user, const char *pass);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_StreamCreateFileAuth LIB "basswma.dll" ALIAS "BASS_WMA_StreamCreateFileAuth" ( _
   BYVAL LONG _                               ' __in BOOL mem
 , BYREF ANY _                                ' __in const void *file
 , BYVAL QUAD _                               ' __in QWORD offset
 , BYVAL QUAD _                               ' __in QWORD length
 , BYVAL DWORD _                              ' __in DWORD flags
 , BYREF ASCIIZ _                             ' __in const char *user
 , BYREF ASCIIZ _                             ' __in const char *pass
 ) AS DWORD                                   ' HSTREAM

' ========================================================================================
' Creates a sample stream from a WMA file via user callback functions.
' HSTREAM BASSWMADEF(BASS_WMA_StreamCreateFileUser)(DWORD system, DWORD flags,
' const BASS_FILEPROCS *procs, void *user);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_StreamCreateFileUser LIB "basswma.dll" ALIAS "BASS_WMA_StreamCreateFileUser" ( _
   BYVAL DWORD _                              ' __in DWORD system
 , BYVAL DWORD _                              ' __in DWORD flags
 , BYREF BASS_FILEPROCS _                     ' __in const BASS_FILEPROCS *procs
 , BYREF ANY _                                ' __in void *user
 ) AS DWORD                                   ' HSTREAM

' ========================================================================================
' Retrieves the WMA encoding bitrates available for a specified sample format.
' const DWORD *BASSWMADEF(BASS_WMA_EncodeGetRates)(DWORD freq, DWORD chans, DWORD flags);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeGetRates LIB "basswma.dll" ALIAS "BASS_WMA_EncodeGetRates" ( _
   BYVAL DWORD _                              ' __in DWORD freq
 , BYVAL DWORD _                              ' __in DWORD chans
 , BYVAL DWORD _                              ' __in DWORD flags
 ) AS DWORD                                   ' DWORD *

' ========================================================================================
' Initializes WMA encoding to a user defined function.
' HWMENCODE BASSWMADEF(BASS_WMA_EncodeOpen)(DWORD freq, DWORD chans, DWORD flags,
' DWORD bitrate, WMENCODEPROC *proc, void *user);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeOpen LIB "basswma.dll" ALIAS "BASS_WMA_EncodeOpen" ( _
   BYVAL DWORD _                              ' __in DWORD freq
 , BYVAL DWORD _                              ' __in DWORD chans
 , BYVAL DWORD _                              ' __in DWORD flags
 , BYVAL DWORD _                              ' __in DWORD bitrate
 , BYVAL DWORD _                              ' __in WMENCODEPROC *proc
 , BYREF ANY _                                ' __in void *user
 ) AS DWORD                                   ' HWMENCODE

' ========================================================================================
' Initializes WMA encoding to a file.
' HWMENCODE BASSWMADEF(BASS_WMA_EncodeOpenFile)(DWORD freq, DWORD chans, DWORD flags,
' DWORD bitrate, const char *file);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeOpenFile LIB "basswma.dll" ALIAS "BASS_WMA_EncodeOpenFile" ( _
   BYVAL DWORD _                              ' __in DWORD freq
 , BYVAL DWORD _                              ' __in DWORD chans
 , BYVAL DWORD _                              ' __in DWORD flags
 , BYVAL DWORD _                              ' __in DWORD bitrate
 , BYREF ASCIIZ _                             ' __in const char *file
 ) AS DWORD                                   ' HWMENCODE

' ========================================================================================
' Initializes WMA encoding to the network.
' HWMENCODE BASSWMADEF(BASS_WMA_EncodeOpenNetwork)(DWORD freq, DWORD chans, DWORD flags,
' DWORD bitrate, DWORD port, DWORD clients);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeOpenNetwork LIB "basswma.dll" ALIAS "BASS_WMA_EncodeOpenNetwork" ( _
   BYVAL DWORD _                              ' __in DWORD freq
 , BYVAL DWORD _                              ' __in DWORD chans
 , BYVAL DWORD _                              ' __in DWORD flags
 , BYVAL DWORD _                              ' __in DWORD bitrate
 , BYVAL DWORD _                              ' __in DWORD port
 , BYVAL DWORD _                              ' __in DWORD clients
 ) AS DWORD                                   ' HWMENCODE

' ========================================================================================
' Initializes WMA encoding to the network, using multiple bitrates.
' HWMENCODE BASSWMADEF(BASS_WMA_EncodeOpenNetworkMulti)(DWORD freq, DWORD chans,
' DWORD flags, const DWORD *bitrates, DWORD port, DWORD clients);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeOpenNetworkMulti LIB "basswma.dll" ALIAS "BASS_WMA_EncodeOpenNetworkMulti" ( _
   BYVAL DWORD _                              ' __in DWORD freq
 , BYVAL DWORD _                              ' __in DWORD chans
 , BYVAL DWORD _                              ' __in DWORD flags
 , BYREF DWORD _                              ' __in DWORD *bitrates
 , BYVAL DWORD _                              ' __in DWORD port
 , BYVAL DWORD _                              ' __in DWORD clients
 ) AS DWORD                                   ' HWMENCODE

' ========================================================================================
' Initializes WMA encoding to a publishing point on a Windows Media server.
' HWMENCODE BASSWMADEF(BASS_WMA_EncodeOpenPublish)(DWORD freq, DWORD chans, DWORD flags,
' DWORD bitrate, const char *url, const char *user, const char *pass);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeOpenPublish LIB "basswma.dll" ALIAS "BASS_WMA_EncodeOpenPublish" ( _
   BYVAL DWORD _                              ' __in DWORD freq
 , BYVAL DWORD _                              ' __in DWORD chans
 , BYVAL DWORD _                              ' __in DWORD flags
 , BYVAL DWORD _                              ' __in DWORD bitrate
 , BYREF ASCIIZ _                             ' __in const char *url
 , BYREF ASCIIZ _                             ' __in const char *user
 , BYREF ASCIIZ _                             ' __in const char *pass
 ) AS DWORD                                   ' HWMENCODE

' ========================================================================================
' Initializes WMA encoding to a publishing point on a Windows Media server, using multiple bitrates.
' HWMENCODE BASSWMADEF(BASS_WMA_EncodeOpenPublishMulti)(DWORD freq, DWORD chans,
' DWORD flags, const DWORD *bitrates, const char *url, const char *user, const char *pass);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeOpenPublishMulti LIB "basswma.dll" ALIAS "BASS_WMA_EncodeOpenPublishMulti" ( _
   BYVAL DWORD _                              ' __in DWORD freq
 , BYVAL DWORD _                              ' __in DWORD chans
 , BYVAL DWORD _                              ' __in DWORD flags
 , BYREF DWORD _                              ' __in DWORD *bitrates
 , BYREF ASCIIZ _                             ' __in const char *url
 , BYREF ASCIIZ _                             ' __in const char *user
 , BYREF ASCIIZ _                             ' __in const char *pass
 ) AS DWORD                                   ' HWMENCODE

' ========================================================================================
' Retrieves the network port for clients to connect to.
' DWORD BASSWMADEF(BASS_WMA_EncodeGetPort)(HWMENCODE handle);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeGetPort LIB "basswma.dll" ALIAS "BASS_WMA_EncodeGetPort" ( _
   BYVAL DWORD _                              ' __in HWMENCODE handle
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Sets a client connection notification callback on a network encoder.
' BOOL BASSWMADEF(BASS_WMA_EncodeSetNotify)(HWMENCODE handle, CLIENTCONNECTPROC *proc, void *user);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeSetNotify LIB "basswma.dll" ALIAS "BASS_WMA_EncodeSetNotify" ( _
   BYVAL DWORD _                              ' __in HWMENCODE handle
 , BYVAL DWORD _                              ' CLIENTCONNECTPROC *proc
 , BYREF ANY _                                ' void *user
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Retrieves the number of clients currently connected to the encoder.
' DWORD BASSWMADEF(BASS_WMA_EncodeGetClients)(HWMENCODE handle);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeGetClients LIB "basswma.dll" ALIAS "BASS_WMA_EncodeGetClients" ( _
   BYVAL DWORD _                              ' __in HWMENCODE handle
 ) AS DWORD                                   ' DWORD

' ========================================================================================
' Sets a tag in a WMA encoding.
' BOOL BASSWMADEF(BASS_WMA_EncodeSetTag)(HWMENCODE handle, const char *tag, const char *text, DWORD type);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeSetTag LIB "basswma.dll" ALIAS "BASS_WMA_EncodeSetTag" ( _
   BYVAL DWORD _                              ' __in HWMENCODE handle
 , BYREF ASCIIZ _                             ' __in const char *tag
 , BYREF ASCIIZ _                             ' __in const char *text
 , BYVAL DWORD _                              ' __in DWORD type
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Encodes sample data, and writes it to the file or network.
' BOOL BASSWMADEF(BASS_WMA_EncodeWrite)(HWMENCODE handle, const void *buffer, DWORD length);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeWrite LIB "basswma.dll" ALIAS "BASS_WMA_EncodeWrite" ( _
   BYVAL DWORD _                              ' __in HWMENCODE handle
 , BYREF ANY _                                ' __in const void *buffer
 , BYVAL DWORD _                              ' __in DWORD length
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Finishes encoding and closes the file or network port.
' BOOL BASSWMADEF(BASS_WMA_EncodeClose)(HWMENCODE handle);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_EncodeClose LIB "basswma.dll" ALIAS "BASS_WMA_EncodeClose" ( _
   BYVAL DWORD _                              ' __in HWMENCODE handle
 ) AS LONG                                    ' BOOL

' ========================================================================================
' Retrieves a pointer to the IWMReader interface of a WMA stream, or IWMWriter interface
' of a WMA encoder.
' void *BASSWMADEF(BASS_WMA_GetWMObject)(DWORD handle);
' ========================================================================================
DECLARE FUNCTION BASS_WMA_GetWMObject LIB "basswma.dll" ALIAS "BASS_WMA_GetWMObject" ( _
   BYVAL DWORD _                              ' __in DWORD handle
 ) AS DWORD                                   ' void *

#ENDIF   ' #IF BASSVERSION = &H204

#ENDIF   ' %BASSWMA_INC
